"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var sinon = require("sinon");
var mongo_entity_1 = require("../mongo_entity");
var testing_1 = require("../testing");
var assert = require("power-assert");
var proxyquire = require("proxyquire");
var CutomEntity = (function (_super) {
    __extends(CutomEntity, _super);
    function CutomEntity() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = 'customEntity';
        return _this;
    }
    return CutomEntity;
}(mongo_entity_1.default));
describe('Testing Helpers', function () {
    describe('withEntity', function () {
        it('cleans up after error has been thrown', function () { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            var deleteSpy, ex_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        deleteSpy = null;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, testing_1.withEntity(function (entity) { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    deleteSpy = sinon.spy(entity, 'deleteMany');
                                    throw new Error('Error');
                                });
                            }); })];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        ex_1 = _a.sent();
                        return [3 /*break*/, 4];
                    case 4:
                        sinon.assert.calledOnce(deleteSpy);
                        return [2 /*return*/];
                }
            });
        }); });
        it('can create custom entities', function () { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, testing_1.withEntity(function (entity) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                assert.equal(entity.name, 'customEntity');
                                return [2 /*return*/];
                            });
                        }); }, { entities: [{ type: CutomEntity }] })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('can create multiple entities', function () { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, testing_1.withEntity(function (one, two) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                assert.equal(one.collection.collectionName, 'One');
                                assert.equal(two.collection.collectionName, 'Two');
                                return [2 /*return*/];
                            });
                        }); }, { entities: [{ name: 'One' }, { name: 'Two' }] })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('withContext', function () {
        it('throws error when no initContext is specified', function () { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            var message, ex_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        message = '';
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, testing_1.withContext(function (context) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                return [2 /*return*/];
                            }); }); })];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        ex_2 = _a.sent();
                        message = ex_2.message;
                        return [3 /*break*/, 4];
                    case 4:
                        assert.equal(message, 'No initContext provided, please pass as a parameter or use global config');
                        return [2 /*return*/];
                }
            });
        }); });
        it('initializes context with connection, executes tests and cleans up afterwards', function () {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                function initContext(conn) {
                    return {
                        entity: new mongo_entity_1.default(conn, 'col'),
                        other: {}
                    };
                }
                var inContext, deleteSpy;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            inContext = null;
                            deleteSpy = null;
                            return [4 /*yield*/, testing_1.withContext(function (context) { return __awaiter(_this, void 0, void 0, function () {
                                    return __generator(this, function (_a) {
                                        assert(context.entity);
                                        deleteSpy = sinon.spy(context.entity, 'deleteMany');
                                        inContext = context;
                                        return [2 /*return*/];
                                    });
                                }); }, initContext)];
                        case 1:
                            _a.sent();
                            sinon.assert.calledOnce(deleteSpy);
                            return [2 /*return*/];
                    }
                });
            });
        });
        it('throws exception but also cleans up', function () {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                function initContext(conn) {
                    return {
                        entity: new mongo_entity_1.default(conn, 'col')
                    };
                }
                var inContext, deleteSpy, ex_3;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            inContext = null;
                            deleteSpy = null;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, testing_1.withContext(function (context) { return __awaiter(_this, void 0, void 0, function () {
                                    return __generator(this, function (_a) {
                                        deleteSpy = sinon.spy(context.entity, 'deleteMany');
                                        inContext = context;
                                        throw new Error('Error');
                                    });
                                }); }, initContext)];
                        case 2:
                            _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            ex_3 = _a.sent();
                            assert.equal(ex_3.message, 'Error');
                            return [3 /*break*/, 4];
                        case 4:
                            sinon.assert.calledOnce(deleteSpy);
                            return [2 /*return*/];
                    }
                });
            });
        });
        it('can run from the globally declared contextFunction', function () { return __awaiter(_this, void 0, void 0, function () {
            var initContext;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        initContext = sinon
                            .stub()
                            .returns({});
                        testing_1.config({ initContext: initContext });
                        return [4 /*yield*/, testing_1.withContext(function () { })];
                    case 1:
                        _a.sent();
                        sinon.assert.calledOnce(initContext);
                        return [2 /*return*/];
                }
            });
        }); });
        it('can run in the disconnected state', function () { return __awaiter(_this, void 0, void 0, function () {
            var MongoStub, _a, withContext, config, initContext;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        MongoStub = {
                            MongoClient: sinon.stub()
                        };
                        _a = proxyquire('../testing', { 'mongodb': MongoStub }), withContext = _a.withContext, config = _a.config;
                        initContext = function (connector) {
                            assert(connector.collection());
                            return {};
                        };
                        config({ initContext: initContext });
                        return [4 /*yield*/, withContext(function (context) { }, null, true)];
                    case 1:
                        _b.sent();
                        sinon.assert.notCalled(MongoStub.MongoClient);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('withServer', function () {
        var server;
        beforeEach(function () {
            server = {
                startTest: sinon.stub(),
                stopTest: sinon.stub(),
                context: [{ dispose: sinon.stub() }]
            };
        });
        it('throws error when no server is specified', function () { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            var message, ex_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        message = '';
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, testing_1.withServer(function (context) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                return [2 /*return*/];
                            }); }); })];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        ex_4 = _a.sent();
                        message = ex_4.message;
                        return [3 /*break*/, 4];
                    case 4:
                        assert.equal(message, 'No server provided, please pass as a parameter or use global config');
                        return [2 /*return*/];
                }
            });
        }); });
        it('starts a new server when server is not started', function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, testing_1.withServer(function (context) { }, server)];
                    case 1:
                        _a.sent();
                        sinon.assert.calledOnce(server.startTest);
                        return [2 /*return*/];
                }
            });
        }); });
        it('cleans up resources even with exception', function () { return __awaiter(_this, void 0, void 0, function () {
            var ex_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, testing_1.withServer(function (context) { throw ''; }, server)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        ex_5 = _a.sent();
                        return [3 /*break*/, 3];
                    case 3:
                        sinon.assert.calledOnce(server.context[0].dispose);
                        return [2 /*return*/];
                }
            });
        }); });
        it('stops server', function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, testing_1.withServer(function (server) {
                                testing_1.disposeServer(true);
                                sinon.assert.calledOnce(server.stopTest);
                            }, server)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        });
    });
    describe('Mocha helpers', function () {
        describe('itWithContext', function () {
            testing_1.itWithContext('runs', function (context) {
                assert(true);
            });
        });
        describe('itWithEntity', function () {
            testing_1.itWithEntity('runs', function (context) {
                assert(true);
            });
        });
        describe('itWithServer', function () {
            var server = {
                startTest: sinon.stub(),
                context: []
            };
            testing_1.itWithServer('runs', function (context) {
                assert(true);
            }, server);
        });
    });
    describe('disposeDb', function () {
        it('closes connection', sinon.test(function () {
            return __awaiter(this, void 0, void 0, function () {
                var dbSpy, MongoStub, _a, getDb, disposeDb;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            dbSpy = {
                                dropDatabase: this.spy(),
                                close: this.spy()
                            };
                            MongoStub = {
                                MongoClient: {
                                    connect: this.stub().returns(dbSpy)
                                }
                            };
                            _a = proxyquire('../testing', { 'mongodb': MongoStub }), getDb = _a.getDb, disposeDb = _a.disposeDb;
                            return [4 /*yield*/, getDb()];
                        case 1:
                            _b.sent();
                            return [4 /*yield*/, disposeDb(true)];
                        case 2:
                            _b.sent();
                            sinon.assert.calledOnce(dbSpy.dropDatabase);
                            sinon.assert.calledOnce(dbSpy.close);
                            return [2 /*return*/];
                    }
                });
            });
        }));
    });
});
